/*
 * Written By Douglas A. Lewis <dalewis@cs.Buffalo.EDU>
 *
 * This file is in the public domain.
 */

#ifndef lint
static	char	rcsid[] = "@(#)$Id: reg.c,v 2.1 1994/10/09 06:53:55 mrg Stab $";
#endif

#include "irc.h"

#include "ircaux.h"

static	int	total_explicit;

/*
 * The following #define is here because we *know* its behaviour.
 * The behaviour of toupper tends to be undefined when it's given
 * a non lower case letter.
 * All the systems supported by IRCII should be ASCII
 */
#define	mkupper(c)	(((c) >= 'a' && (c) <= 'z') ? ((c) - 'a' + 'A') : c)

/* -----------------------------------------------------------------------
 * warning - only define CLIENT_COMPILE if you are compiling for the client
 * If you are not compiling the client, #undef CLIENT_COMPILE
 * NOTE: you need both _match and matches()
 * ----------------------------------------------------------------------- */

#define CLIENT_COMPILE
#undef USE_CALLS

#ifdef CLIENT_COMPILE
#  define RETURN_FALSE -1
#  define RETURN_TRUE count
#else
#  define RETURN_FALSE 1
#  define RETURN_TRUE 0
#endif

int _wild_match(mask, string)
     char *mask, *string;
{
  register char *m = mask, *n = string, *ma = NULL, *na = NULL, temp;
  int just = 0;
#ifdef CLIENT_COMPILE
  char *pm = NULL, *pn = NULL;
  int lp_c = 0, count = 0, last_count = 0;
#endif

#ifdef USE_CALLS
  calls = 0;
#endif

  while(1)
    {

#ifdef USE_CALLS
      calls++;
#endif

      switch (*m)
	{
	case '*':
	  goto ultimate_lameness;
	  break;
#ifdef CLIENT_COMPILE
	case '%':
	  goto ultimate_lameness2;
	  break;
#endif
	case '?':
	  m++;
	  if (!*n++) return RETURN_FALSE;
	  break;
	case 0:
	  if (!*n)
	    return RETURN_TRUE;
	case '\\':
	  if ((*m=='\\') && (m[1]=='*') || (m[1]=='?')) m++;
	default:
	  if (mkupper(*m) != mkupper(*n))
	    return RETURN_FALSE;
	  else
	    {
#ifdef CLIENT_COMPILE
	      count++;
#endif
	      m++;
	      n++;
	    }
	}
    }

  while(1)
    {

#ifdef USE_CALLS
      calls++;
#endif

      switch (*m)
	{
	case '*':
ultimate_lameness:
	  ma = ++m;
	  na = n;
	  just = 1;
#ifdef CLIENT_COMPILE
	  last_count = count;
#endif
	  break;
#ifdef CLIENT_COMPILE
	case '%':
ultimate_lameness2:
	  pm = ++m;
	  pn = n;
	  lp_c = count;
	  break;
#endif
	case '?':
	  m++;
	  if (!*n++) return RETURN_FALSE;
	  break;
	case 0:
	  if (!*n || just)
	    return RETURN_TRUE;
	case '\\':
	  if ((*m=='\\') && (m[1]=='*') || (m[1]=='?')) m++;
	default:
#ifdef CLIENT_COMPILE
	  if (*n==' ') pm = NULL;
#endif
	  just = 0;
	  if (mkupper(*m) != mkupper(*n))
	    {
	      if (!*n) return RETURN_FALSE;
#ifdef CLIENT_COMPILE
	      if (pm)
		{
		  m = pm;
		  n = ++pn;
		  if (!*n) return RETURN_FALSE;
		  count = lp_c;
		}
	      else
#endif	       
		if (ma)
		  {
		    m = ma;
		    n = ++na;
		    if (!*n) return RETURN_FALSE;
#ifdef CLIENT_COMPILE
		    count = last_count;
#endif
		  }
		else return RETURN_FALSE;
	    }
	  else
	    {
#ifdef CLIENT_COMPILE
	      count++;
#endif
	      m++;
	      n++;
	    }
	}
    }
}

int	match(pattern, string)
char	*pattern, *string;
{
/* -1 on false >= 0 on true */
  return ((_wild_match(pattern, string)>=0)?1:0);
}

int	wild_match(pattern, str)
char	*pattern,
	*str;
{

/* assuming a -1 return of false */
	return _wild_match(pattern, str) + 1;
}
